// classify.c   // 
#include"mex.h"
#include"math.h"
void performance(double *okcnt, const double *mdist, const double *mdistclass, const double *classnumber,
        const double *classcg, const double *maxcg, const double *netalpha, 
        const double *netd_aa, const double *hyperpara, const double *nn, 
        const double *ddim, const double *netpai){
   int j, addralp, d, d2, jud, class, c, classn, n, ccg[100], mcg, dim, addr;
   double mmgc, classmmg[10], maxmg, hp0, hp1;
   
// ------------------------
   classn=(int)*classnumber; n=(int)*nn; addr=0;  // mexPrintf("n= %5d\n",n); 
   for(class=0;class<classn;class++){ccg[class]=(int)classcg[class];}   
   dim=(int)*ddim; hp0=1.0/hyperpara[0]; hp1=-1.0/hyperpara[1]; 
   *okcnt=0; mcg=(int)*maxcg;  
for(j=0;j<n;j++){      
       addralp=0; 
   for(class=0;class<classn;class++){  
         classmmg[class]=0.0; 
      for(c=0;c<ccg[class];c++){
  mmgc=netalpha[c+addralp]/pow(hyperpara[2]+mdist[c+addralp+addr],hp0)
                    *pow(netd_aa[c+addralp],hp1); 
      classmmg[class]+=mmgc; 
      } // c
      addralp+=mcg; classmmg[class]=netpai[class]*classmmg[class]; 
   } //class
   addr+=classn*mcg;  
   maxmg=0; 
  for(class=0;class<classn;class++){
      if(classmmg[class]>maxmg){
          maxmg=classmmg[class];
          jud=class;
      }
  }
  if(jud==(int)(mdistclass[j]-1)){*okcnt+=1;}
} // j
}

void mexFunction( int Nreturned, mxArray *returned[], int Noperand, const mxArray *operand[]){
  double *okcnt, *mdist, *mdistclass, *classnumber, *classcg, *maxcg,  
          *netalpha, *netd_aa, *hyperpara, *nn, *ddim, *netpai;
    returned[0] = mxCreateDoubleMatrix(1,1, mxREAL);
  /* Matlab variables are copied to address of C variables */
  mdist = mxGetPr(operand[0]); mdistclass = mxGetPr(operand[1]); classnumber = mxGetPr(operand[2]);  
  classcg= mxGetPr(operand[3]); maxcg= mxGetPr(operand[4]); netalpha= mxGetPr(operand[5]); 
  netd_aa= mxGetPr(operand[6]); hyperpara= mxGetPr(operand[7]);  
  nn= mxGetPr(operand[8]); ddim= mxGetPr(operand[9]); netpai= mxGetPr(operand[10]);
  okcnt = mxGetPr(returned[0]); // return variable
  performance(okcnt,mdist,mdistclass,classnumber,classcg,maxcg,netalpha,netd_aa,hyperpara,nn,ddim,netpai);
}

