% function ClusterFixP   
% Fixpoint iteration 
%---------------------------------------
function ClusterFixP
global class ClassCg MaxCg SizeTrainD TrainDD VVg MMg Tg tg AAg D_AA Alpha...
    SW1 SW2 SW3 Nm Beta obj1 Block BlockN

    Dist=zeros(MaxCg,1); D_AA=zeros(MaxCg,1); obj1=0;
    Cg=ClassCg(class); VVg(1:Cg,:)=zeros(Cg,SizeTrainD(2)-1);
    SumMM=zeros(1,Cg); Pai(1)=0; 
    for i=1:BlockN
    if i*Block<=SizeTrainD(1) EndN=Block; else EndN=SizeTrainD(1)-(i-1)*Block; end
    Pai(1)=Pai(1)+EndN; 
    DDD=TrainDD(2:size(TrainDD,1),1:EndN,i); % cut class info
      for clust=1:Cg
      VVg(clust,:)=VVg(clust,:)+sum(DDD.*(ones(size(DDD,1),1)*MMg(1:EndN,clust,i)'),2)';
      SumMM(clust)=SumMM(clust)+sum(MMg(1:EndN,clust,i)); 
      end % clust
    end % i
    for clust=1:Cg
      VVg(clust,:)=VVg(clust,:)./SumMM(clust);
    end
    for i=1:BlockN
      if i*Block<=SizeTrainD(1) EndN=Block; else EndN=SizeTrainD(1)-(i-1)*Block; end
      for clust=1:Cg
        DDD=TrainDD(2:size(TrainDD,1),1:EndN,i); % cut class info
        DDD=DDD-VVg(clust,:)'*ones(1,size(DDD,2)); % NX^[S
        DDD=DDD.*(ones(size(DDD,1),1)*MMg(1:EndN,clust,i)'); 
        if i==1 
          AAg(:,:,clust)=DDD*DDD'; 
        else
          AAg(:,:,clust)=AAg(:,:,clust)+DDD*DDD'; 
        end % if i
      end % clust
    end % i
    for clust=1:Cg
      AAg(:,:,clust)=AAg(:,:,clust)./SumMM(clust);
      if SW2==1 
         if SizeTrainD(2)-1 > Nm 
         opts.disp=0; [PP1,LL]=eigs(AAg(:,:,clust),Nm,'lm',opts);
         VarianEsti=(trace(AAg(:,:,clust))-trace(LL))./(SizeTrainD(2)-1-Nm);
         D_AA(clust)=det(LL).*VarianEsti^(SizeTrainD(2)-1-Nm); 
         AAg(:,:,clust)=PP1*inv(LL)*PP1'-PP1*PP1'./VarianEsti...
              +eye(SizeTrainD(2)-1)./VarianEsti;
         else 
         [PP1,LL]=eig(full(AAg(:,:,clust)));
         D_AA(clust,1)=det(LL);
         AAg(:,:,clust)=PP1*inv(LL)*PP1';
         end
      else 
         D_AA(clust)=1; AAg(:,:,clust)=eye(SizeTrainD(2)-1); 
      end 
    end % clust
    SumClassMMg=zeros(1,MaxCg);
if tg<Tg    
    t01 = clock;  % AA=AAg(1:5,1:5,1) 
   for i=1:BlockN
      if i*Block<=SizeTrainD(1) EndN=Block; else EndN=SizeTrainD(1)-(i-1)*Block; end
       DD=TrainDD(2:size(TrainDD,1),1:EndN,i); % cut class info
       Dim=SizeTrainD(2);            
% MEX C %%%%%%%%%%%%%       
       [MM,obj1]=mmgupdt(EndN,Cg,VVg',DD,AAg,D_AA,obj1,Dim);
       MMg(1:EndN,1:Cg,i)=MM(1:Cg,1:EndN)';

      SumClassMMg=SumClassMMg+sum(MMg(1:EndN,:,i));
   end % i
  if SW1==0 
   Alpha(:,1)=ones(Cg,1); 
  else
   Alpha(1:Cg,1)=SumClassMMg./sum(SumClassMMg); %sum(SumClassMMg)
  end % i
Disp=sprintf('t=%4d Obj=%9.5f',tg,obj1./sum(SumClassMMg));
    disp(Disp); 
    MMgTime=etime(clock,t01)
end% if tg <Tg
    
    

