// mmgupdt.c   // 
#include"mex.h"
#include"math.h"
void mmgupdt(double *mm, double *obj1, const double *endn, const double *cg,
  const double *vvg, const double *dd, const double *aag, const double *d_aa, 
  const double *obj0, const double *dim){
    int iendn, icg, iiicg, kk, clust, minclust, addrv, addr;
    int addraa, d1, d2, ddim, sizeaa, addraaclass; 
    double mdistv[100], mdist, disclust[200], mindis, ddd[100];
    
addr=0; ddim=(int)*dim-1; *obj1=*obj0; iiicg=0; 
icg=(int)*cg; iendn=(int)*endn; sizeaa=(int)(ddim*ddim);
for(kk=0;kk<iendn;kk++){
   addrv=0;  addraaclass=0;
    for(clust=0;clust<icg;clust++){
        for(d1=0;d1<ddim;d1++){mdistv[d1]=0;}
        for(d1=0;d1<ddim;d1++){
          ddd[d1]=dd[addr+d1]-vvg[addrv+d1];
          addraa=0; 
              for(d2=0;d2<ddim;d2++){
              mdistv[d2]+=(aag[addraaclass+addraa+d1])*ddd[d1]; 
              addraa=addraa+ddim;
              } // d2
            } // d1
          mdist=0;  
          for(d2=0;d2<ddim;d2++){
              mdist+=mdistv[d2]*ddd[d2];  
              } // d2  
          disclust[clust]=mdist+log(d_aa[clust]);
          addrv=addrv+ddim;  addraaclass=addraaclass+sizeaa;
        } // clust
  mindis=1e+15;   
  for(clust=0;clust<icg;clust++){
      if(disclust[clust]<mindis){
          mindis=disclust[clust];
          minclust=clust; mm[clust+iiicg]=0;
      }
  } // clust
 mm[minclust+iiicg]=1; *obj1=*obj1+mindis;
 iiicg=iiicg+icg; addr=addr+ddim;    //  mexPrintf("kk %5d\n",kk); 
} // kk

}

void mexFunction( int Nreturned, mxArray *returned[], int Noperand, const mxArray *operand[]){
  double *mm, *obj1, *endn, *cg, *vvg, *dd, *aag, *d_aa, *obj0, *dim;

  /* Matlab variables are copied to address of C variables */
  endn= mxGetPr(operand[0]);  cg = mxGetPr(operand[1]);  
  vvg= mxGetPr(operand[2]);  dd= mxGetPr(operand[3]);  
  aag= mxGetPr(operand[4]);  d_aa= mxGetPr(operand[5]);
  obj0= mxGetPr(operand[6]);  dim= mxGetPr(operand[7]);
  returned[0] = mxCreateDoubleMatrix(*cg,*endn,mxREAL);
  returned[1] = mxCreateDoubleMatrix(1,1,mxREAL);
  mm= mxGetPr(returned[0]); // return variable
  obj1= mxGetPr(returned[1]);
  mmgupdt(mm,obj1,endn,cg,vvg,dd,aag,d_aa,obj0,dim);
}

